# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
from urllib.parse import unquote


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name
    
    url_base = "https://www.wireshark.org/download.html"
    os_type = control.target_os + "-" + ensure_list(control.architecture)[0]

    download_os_dict = {
        'windows-x64': '-x64.exe',
        'darwin-arm': '%20Arm%2064.dmg',
        'darwin-x64': '%20Intel%2064.dmg'
    }

    download_accordion = bs_find(url_base, "div", "id", "download-accordion", proxies=proxies)
    latest_download_accordion = download_accordion.find('div', recursive=False)
    for li in latest_download_accordion.find_all('li'):
        download_url =  li.find('a')['href']
        if download_url.endswith(download_os_dict[os_type]):
            latest_bin = unquote(download_url.rsplit('/', 1)[-1])
            latest_bin_extension = latest_bin.rsplit('.', 1)[-1]
            version = latest_bin.split(' ')[1] # For windows is '-', For darwin is ' '
            break

    # Downloading latest binaries
    print(f"Latest {app_name} version is: {version}")
    print(f"Download URL is: {download_url}")
    if not isfile(latest_bin):
        print(f"Downloading: '{latest_bin}'")
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print(f"Binary is present: '{latest_bin}'")

    # Deleting outdated binaries
    for f in glob.glob(f'*.{latest_bin_extension}'):
        if f != latest_bin:
            remove_file(f)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print(f"Software version updated (from: {control.get_software_version()} to: {version})")
        package_updated = True
    else:
        print(f"Software version up-to-date ({version})")

    control.set_software_version(version)
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated